/* KallistiGL for KOS 1.1.5

   glkos.c
   (c)2001 Dan Potter
*/

static char id[] = "KGL $Id: glkos.c,v 1.3 2001/10/19 06:04:34 bardtx Exp $";

#include <dc/video.h>
#include <dcutils/pvrutils.h>
#include <stdio.h>
#include <string.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include "glinternal.h"

/* KOS-specific APIs */

int glKosInit() {
	GLfloat w, h;
	
	/* Pre-initialize all the globals */
	gl_clear_color[0] =
		gl_clear_color[1] =
		gl_clear_color[2] =
		gl_clear_color[3] = 0.0f;
	gl_capabilities = 0;
	gl_prim_type = 0;
	gl_pbuf_submitted = GL_FALSE;
	gl_enabled_lists = GL_LIST_OPAQUE_POLY | GL_LIST_TRANS_POLY;
	gl_active_list = GL_LIST_NONE;

	/* Reset all matrices */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glMatrixMode(GL_TEXTURE);
	glLoadIdentity();

	/* Setup some basic polygon headers */
	ta_poly_hdr_col(&gl_null_texture.pbuf_opaque, TA_OPAQUE);
	ta_poly_hdr_col(&gl_null_texture.pbuf_trans, TA_TRANSLUCENT);
	gl_cur_texture = &gl_null_texture;

	/* Initialize the viewport */
	glKosGetScreenSize(&w, &h);
	glViewPort(0, 0, (GLsizei)w, (GLsizei)h);

	return 0;
}

void glKosShutdown() {
}

void glKosGetScreenSize(GLfloat *w, GLfloat *h) {
	*w = vid_mode->width;
	*h = vid_mode->height;
}

void glKosBeginFrame() {
	ta_begin_render();
	gl_pbuf_submitted = GL_FALSE;
	gl_active_list = GL_LIST_OPAQUE_POLY;
}

/* XXX Note: doesn't work for any arrangement yet except for the two
   normal lists (opaque polys, trans polys) */
void glKosFinishFrame() {
	while (gl_active_list != GL_LIST_OPAQUE_MOD)
		glKosFinishList();
	ta_finish_frame();
}

void glKosFinishList() {
	switch(gl_active_list) {
	case GL_LIST_OPAQUE_POLY:
		pvr_dummy_poly(TA_OPAQUE);
		ta_commit_eol();
		break;
	case GL_LIST_TRANS_POLY:
		pvr_dummy_poly(TA_TRANSLUCENT);
		ta_commit_eol();
		break;
	default:
		dbglog(DBG_ERROR, "gl: invalid list was active in glKosFinishList!");
	}

	/* Advance to the next list */
	gl_active_list = gl_active_list << 1;

	/* We haven't submitted the new poly headers */
	gl_pbuf_submitted = GL_FALSE;
}


